<?php
	require_once('connect.inc');

	if (!$link = my_mysqli_connect($host, $user, $passwd, $db, $port, $socket)) {
		printf("[001] Cannot connect to the server using host=%s, user=%s, passwd=***, dbname=%s, port=%s, socket=%s\n",
		  $host, $user, $db, $port, $socket);
	}

	if (!mysqli_query($link, 'DROP PROCEDURE IF EXISTS p'))
		printf("[003] [%d] %s.\n", mysqli_errno($link), mysqli_error($link));

	if (mysqli_real_query($link, 'CREATE PROCEDURE p(IN ver_in VARCHAR(25), OUT ver_out VARCHAR(25)) BEGIN SELECT ver_in INTO ver_out; END;')) {
		if (!$stmt = mysqli_prepare($link, 'CALL p(?, ?)'))
			printf("[005] Cannot prepare CALL, [%d] %s\n", mysqli_errno($link), mysqli_error($link));

		$ver_in = 'myversion';
		$ver_out = '';
		if (!mysqli_stmt_bind_param($stmt, 'ss', $ver_in, $ver_out))
			printf("[006] Cannot bind parameter, [%d] %s\n", mysqli_stmt_errno($stmt), mysqli_stmt_error($stmt));

		if (!mysqli_stmt_execute($stmt))
			printf("[007] Cannot execute CALL, [%d] %s\n", mysqli_stmt_errno($stmt), mysqli_stmt_error($stmt));

		printf("[008] More results: %s\n", (mysqli_more_results($link) ? "yes" : "no"));
		printf("[009] Next results: %s\n", (mysqli_next_result($link) ? "yes" : "no"));

		if (!mysqli_stmt_bind_result($stmt, $ver_out) || !mysqli_stmt_fetch($stmt))
			printf("[010] [%d] %s\n", mysqli_stmt_errno($stmt), mysqli_stmt_error($stmt));

		if ("myversion" !== $ver_out)
			printf("[011] Results seem wrong got '%s'\n", $ver_out);

		if (!mysqli_stmt_close($stmt))
			printf("[012] Cannot close statement, [%d] %s\n", mysqli_stmt_errno($stmt), mysqli_stmt_error($stmt));

		if (!$res = $link->query("SELECT 1"))
			printf("[013] [%d] %s\n", $link->errno, $link->error);

	} else {
		printf("[004] Cannot create SP, [%d] %s.\n", mysqli_errno($link), mysqli_error($link));
	}

	mysqli_close($link);
	print "done!";
?>
