<?php

/* Prototype  : string hebrev  ( string $hebrew_text  [, int $max_chars_per_line  ] )
 * Description: Convert logical Hebrew text to visual text
 * Source code: ext/standard/string.c
*/

echo "*** Testing hebrev() function: with unexpected inputs for 'hebrew_text' argument ***\n";

//get an unset variable
$unset_var = 'string_val';
unset($unset_var);

//defining a class
class sample  {
  public function __toString() {
    return "sample object";
  } 
}

//getting the resource
$file_handle = fopen(__FILE__, "r");

// array with different values for $hebrew_text
$texts =  array (

		  // integer values
/*1*/	  0,
		  1,
		  255,
		  256,
	      2147483647,
		  -2147483648,
		
		  // float values
/*7*/	  10.5,
		  -20.5,
		  10.1234567e5,
		
		  // array values
/*10*/	  array(),
		  array(0),
		  array(1, 2),
		
		  // boolean values
/*13*/	  true,
		  false,
		  TRUE,
		  FALSE,
		
		  // null values
/*17*/	  NULL,
		  null,
		
		  // objects
/*19*/	  new sample(),
		
		  // resource
/*20*/	  $file_handle,
		
		  // undefined variable
/*21*/	  @$undefined_var,
		
		  // unset variable
/*22*/	  @$unset_var,

          // text with parentheses
          'text with parentheses (',
          'text with parentheses )',

          // text with brackets
          'text with bracket [',
          'text with bracket ]',

          // text with curly brackets
          'text with curly bracket {',
          'text with curly bracket }',

          // text with backslash escape
          'text with backslash escape \\',

          // text with a slash char
          'text with a slash char /',

          // text with a greater than char
          'text with a greater than char >',

          // text with a less than char
          'text with a less than char <'
);

// loop through with each element of the $texts array to test hebrev() function
$count = 1;

foreach($texts as $hebrew_text) {
  echo "-- Iteration $count --\n";
  var_dump( hebrev($hebrew_text) );
  $count ++;
}

fclose($file_handle);  //closing the file handle

?>
===DONE===
